<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_TransferBookingInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_TransferBookingInfo extends AbstractStructArrayBase
{
    /**
     * The TransferBookingInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_TransferBookingInfo[]
     */
    public $TransferBookingInfo;
    /**
     * Constructor method for ArrayOfJP_TransferBookingInfo
     * @uses ArrayOfJP_TransferBookingInfo::setTransferBookingInfo()
     * @param \StructType\JP_TransferBookingInfo[] $transferBookingInfo
     */
    public function __construct(array $transferBookingInfo = array())
    {
        $this
            ->setTransferBookingInfo($transferBookingInfo);
    }
    /**
     * Get TransferBookingInfo value
     * @return \StructType\JP_TransferBookingInfo[]|null
     */
    public function getTransferBookingInfo()
    {
        return $this->TransferBookingInfo;
    }
    /**
     * Set TransferBookingInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_TransferBookingInfo[] $transferBookingInfo
     * @return \ArrayType\ArrayOfJP_TransferBookingInfo
     */
    public function setTransferBookingInfo(array $transferBookingInfo = array())
    {
        foreach ($transferBookingInfo as $arrayOfJP_TransferBookingInfoTransferBookingInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_TransferBookingInfoTransferBookingInfoItem instanceof \StructType\JP_TransferBookingInfo) {
                throw new \InvalidArgumentException(sprintf('The TransferBookingInfo property can only contain items of \StructType\JP_TransferBookingInfo, "%s" given', is_object($arrayOfJP_TransferBookingInfoTransferBookingInfoItem) ? get_class($arrayOfJP_TransferBookingInfoTransferBookingInfoItem) : gettype($arrayOfJP_TransferBookingInfoTransferBookingInfoItem)), __LINE__);
            }
        }
        $this->TransferBookingInfo = $transferBookingInfo;
        return $this;
    }
    /**
     * Add item to TransferBookingInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_TransferBookingInfo $item
     * @return \ArrayType\ArrayOfJP_TransferBookingInfo
     */
    public function addToTransferBookingInfo(\StructType\JP_TransferBookingInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_TransferBookingInfo) {
            throw new \InvalidArgumentException(sprintf('The TransferBookingInfo property can only contain items of \StructType\JP_TransferBookingInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TransferBookingInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_TransferBookingInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_TransferBookingInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_TransferBookingInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_TransferBookingInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_TransferBookingInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TransferBookingInfo
     */
    public function getAttributeName()
    {
        return 'TransferBookingInfo';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_TransferBookingInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
